"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequestIdMiddleware = void 0;
const common_1 = require("@nestjs/common");
const uuid = require("uuid");
const async_1 = require("nanoid/async");
const requestid_constants_1 = require("./requestid.constants");
const requestid_enum_1 = require("./requestid.enum");
const requestid_service_1 = require("./requestid.service");
const requestid_module_definition_1 = require("./requestid.module-definition");
let RequestIdMiddleware = class RequestIdMiddleware {
    constructor(requestIdOptions, requestIdService) {
        this.requestIdOptions = requestIdOptions;
        this.requestIdService = requestIdService;
    }
    async use(req, res, next) {
        var _a, _b;
        const { type, length } = {
            type: (_a = this.requestIdOptions.type) !== null && _a !== void 0 ? _a : requestid_enum_1.RequestIdFormatType.UUID_V4,
            length: (_b = this.requestIdOptions.length) !== null && _b !== void 0 ? _b : 21,
        };
        let requestId;
        switch (type) {
            case requestid_enum_1.RequestIdFormatType.RANDOM:
                requestId = await (0, async_1.nanoid)(length);
                break;
            case requestid_enum_1.RequestIdFormatType.UUID_V1:
                requestId = uuid.v1();
                break;
            case requestid_enum_1.RequestIdFormatType.UUID_V4:
                requestId = uuid.v4();
                break;
            default:
                throw new Error(`Unsupported request ID format type: ${type}`);
        }
        req.headers[requestid_constants_1.REQUEST_ID_HEADER] = requestId;
        res.setHeader(requestid_constants_1.REQUEST_ID_HEADER, requestId);
        this.requestIdService.requestId = req.headers[requestid_constants_1.REQUEST_ID_HEADER];
        this.requestIdService.requestIdType = type;
        this.requestIdService.requestIdLength = length;
        next();
    }
};
RequestIdMiddleware = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(requestid_module_definition_1.MODULE_OPTIONS_TOKEN)),
    __param(1, (0, common_1.Inject)(requestid_constants_1.REQUEST_ID_TOKEN)),
    __metadata("design:paramtypes", [Object, requestid_service_1.RequestIdService])
], RequestIdMiddleware);
exports.RequestIdMiddleware = RequestIdMiddleware;
